From 89e671e3f3d5754e78efc447f13386ced719f1f7 Mon Sep 17 00:00:00 2001
From: Alexander Graf <agraf@suse.de>
Date: Wed, 1 Jul 2009 22:08:21 +0200
Subject: [PATCH] Replace signrom with shell script v3

In order to not execute code we just compiled, let's replace signrom
with a shell script that does the same thing while staying compatible
to pretty much every system available.

This should make cross-compilation for windows easier.

aliguori: fix build when objdir != srcdir

Signed-off-by: Alexander Graf <agraf@suse.de>
Signed-off-by: Anthony Liguori <aliguori@us.ibm.com>
---
 pc-bios/optionrom/Makefile   |  9 ++--
 pc-bios/optionrom/signrom.c  | 79 ------------------------------------
 pc-bios/optionrom/signrom.sh | 45 ++++++++++++++++++++
 3 files changed, 48 insertions(+), 85 deletions(-)
 delete mode 100644 pc-bios/optionrom/signrom.c
 create mode 100755 pc-bios/optionrom/signrom.sh

diff --git a/pc-bios/optionrom/Makefile b/pc-bios/optionrom/Makefile
index c4a6f42625..7f987d898f 100644
--- a/pc-bios/optionrom/Makefile
+++ b/pc-bios/optionrom/Makefile
@@ -37,12 +37,9 @@ build-all: multiboot.bin
 %.img: %.o
 	$(LD) --oformat binary -Ttext 0 -o $@ $<
 
-%.bin: %.img signrom
-	./signrom $< $@
+%.bin: %.img
+	$(SRC_PATH)/pc-bios/optionrom/signrom.sh $< $@
 	cp $@ $(SRC_PATH)/pc-bios/
 
-signrom: signrom.c
-	$(CC) -o $@ -g -Wall $^
-
 clean:
-	$(RM) *.o *.img *.bin signrom *~
+	$(RM) *.o *.img *.bin *~
diff --git a/pc-bios/optionrom/signrom.c b/pc-bios/optionrom/signrom.c
deleted file mode 100644
index fe8d677459..0000000000
--- a/pc-bios/optionrom/signrom.c
+++ /dev/null
@@ -1,79 +0,0 @@
-/*
- * Extended Boot Option ROM
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
- *
- * Copyright IBM Corporation, 2007
- *   Authors: Anthony Liguori <aliguori@us.ibm.com>
- */
-
-#include <stdio.h>
-#include <stdint.h>
-#include <string.h>
-
-int main(int argc, char **argv)
-{
-	FILE *fin, *fout;
-	char buffer[512], oldbuffer[512];
-	int i, size, lag = 0;
-	uint8_t sum = 0;
-
-	if (argc != 3) {
-		printf("Usage: %s ROM OUTPUT\n", argv[0]);
-		return 1;
-	}
-
-	fin = fopen(argv[1], "rb");
-	fout = fopen(argv[2], "wb");
-
-	if (fin == NULL || fout == NULL) {
-		fprintf(stderr, "Could not open input/output files\n");
-		return 1;
-	}
-
-	do {
-		size = fread(buffer, 512, 1, fin);
-		if (size == 1) {
-			for (i = 0; i < 512; i++)
-				sum += buffer[i];
-
-			if (lag) {
-				if (fwrite(oldbuffer, 512, 1, fout) != 1) {
-					fprintf(stderr, "Write failed\n");
-					return 1;
-				}
-			}
-			lag = 1;
-			memcpy(oldbuffer, buffer, 512);
-		}
-	} while (size == 1);
-
-	if (size != 0) {
-		fprintf(stderr, "Failed to read from input file\n");
-		return 1;
-	}
-
-	oldbuffer[511] = -sum;
-
-	if (fwrite(oldbuffer, 512, 1, fout) != 1) {
-		fprintf(stderr, "Failed to write to output file\n");
-		return 1;
-	}
-
-	fclose(fin);
-	fclose(fout);
-
-	return 0;
-}
diff --git a/pc-bios/optionrom/signrom.sh b/pc-bios/optionrom/signrom.sh
new file mode 100755
index 0000000000..4273d1f0e0
--- /dev/null
+++ b/pc-bios/optionrom/signrom.sh
@@ -0,0 +1,45 @@
+#!/bin/sh
+
+# Option ROM Signing utility
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+#
+# Copyright Novell Inc, 2009
+#   Authors: Alexander Graf <agraf@suse.de>
+#
+# Syntax: signrom.sh <input> <output>
+
+# did we get proper arguments?
+test "$1" -a "$2" || exit 1
+
+sum=0
+
+# find out the file size
+x=`dd if="$1" bs=1 count=1 skip=2 2>/dev/null | od -t u1 -A n`
+#size=`expr $x \* 512 - 1`
+size=$(( $x * 512 - 1 ))
+
+# now get the checksum
+for i in `od -A n -t u1 -v "$1"`; do
+    # add each byte's value to sum
+    sum=$(( $sum + $i ))
+done
+
+sum=$(( $sum % 256 ))
+sum=$(( 256 - $sum ))
+
+# and write the output file
+cp "$1" "$2"
+printf "\\$sum" | dd of="$2" bs=1 count=1 seek=$size conv=notrunc 2>/dev/null
-- 
2.42.0